<template>
  <q-form @submit="validateSubmission(form)">
    <div class="row q-mt-md">
      <div class="col-12 q-mb-sm">
        <label class="text-caption text-weight-bold text-grey-7"
          >EMAIL ADDRESS <span class="text-negative">*</span></label
        >
        <q-input
          dense
          outlined
          color="primary"
          bg-color="grey-2"
          v-model="form.email"
          class="q-mt-sm rounded-borders-10"
          :rules="[validations.requiredField, validations.emailFormat]"
        />
      </div>

      <div class="col-12 q-mb-sm">
        <label class="text-caption text-weight-bold text-grey-7"
          >MOBILE NUMBER <span class="text-negative">*</span></label
        >
        <q-input
          v-model="form.mobile_number"
          dense
          outlined
          class="q-mt-sm"
          :rules="[validations.requiredField]"
          v-on:keyup="formatMobileNumber(form.mobile_number)"
          placeholder="xxx-xxx-xxxx"
          maxlength="12"
        >
          <template v-slot:prepend>
            <span class="title-7">(+63)</span>
          </template>
        </q-input>
      </div>

      <div class="col-12 q-mb-sm">
        <label class="text-caption text-weight-bold text-grey-7"
          >PASSWORD <span class="text-negative">*</span></label
        >
        <q-input
          v-model="form.password"
          dense
          outlined
          :type="isFieldPassword ? 'password' : 'text'"
          class="q-mt-sm"
          :rules="[validations.requiredField]"
        >
          <template v-slot:append>
            <q-icon
              :name="
                isFieldPassword ? 'eva-eye-off-outline' : 'eva-eye-outline'
              "
              @click="isFieldPassword = !isFieldPassword"
            />
          </template>
        </q-input>
      </div>

      <div class="col-12 q-mb-sm">
        <label class="text-caption text-weight-bold text-grey-7"
          >CONFIRM PASSWORD <span class="text-negative">*</span></label
        >
        <q-input
          v-model="form.confirmation_password"
          dense
          outlined
          :type="isFieldConfirmPassword ? 'password' : 'text'"
          class="q-mt-sm"
          :rules="[validations.requiredField]"
        >
          <template v-slot:append>
            <q-icon
              :name="
                isFieldConfirmPassword
                  ? 'eva-eye-off-outline'
                  : 'eva-eye-outline'
              "
              @click="isFieldConfirmPassword = !isFieldConfirmPassword"
            />
          </template>
        </q-input>
      </div>
    </div>

    <div class="q-mt-xl q-mb-xl">
      <p v-if="isError === true" class="text-negative text-center">
        {{ errorMessage }}
      </p>
      <div class="row">
        <div class="col flex justify-center">
          <q-btn
            unelevated
            type="submit"
            class="btn-xl btn--shade-1 title-4 text-white rounded-borders-10"
            label="Send Code"
            :loading="loading"
          />
        </div>
      </div>
    </div>
  </q-form>
</template>

<script>
import { LocalStorage } from "quasar";
import { requiredField, emailFormat } from "src/hooks/validations";
import { defineComponent, ref, reactive } from "vue";
import { AuthApi } from "src/hooks/api";
import useAuthHook from "src/modules/auth/hooks/authHook";
import usePageRouter from "src/hooks/pageRouter";

export default defineComponent({
  name: "AccountDetailsForm",

  setup() {
    const { loading } = useAuthHook();
    const { router } = usePageRouter();
    const isError = ref(false);
    const errorMessage = ref("");
    const isFieldPassword = ref(true);
    const isFieldConfirmPassword = ref(true);

    const form = reactive({
      email: "",
      mobile_number: null,
      password: "",
      confirmation_password: "",
      user_type: null,
    });

    const formatMobileNumber = (number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");
      form.mobile_number = formattedNumber;
    };

    const validateSubmission = (form) => {
      if (form.password !== form.confirmation_password) {
        isError.value = true;
        errorMessage.value = "PASSWORDS MUST MATCH.";
      } else {
        doSendCode(form);
      }
    };

    const doSendCode = async (payload) => {
      loading.value = true;
      payload.user_type = "job-seeker";

      await AuthApi.checkEmail(payload)
        .then((response) => {
          LocalStorage.set("userForm", response.data.data);
          LocalStorage.set("passwordForm", form.password);

          setTimeout(() => {
            if (response.data.success === true) {
              router.push("email-verification");
            }
          }, 1000);
        })
        .catch((error) => {
          isError.value = true;
          errorMessage.value = error?.response?.data?.message.toUpperCase();
        })
        .finally(() => {
          loading.value = false;
        });
    };

    return {
      form,
      isFieldPassword,
      isFieldConfirmPassword,
      isError,
      errorMessage,
      loading,
      validations: {
        requiredField,
        emailFormat,
      },
      validateSubmission,
      doSendCode,
      formatMobileNumber,
    };
  },
});
</script>
